## shogun 3.0.1~git20131115.557741b

=== debian/changelog ===
shogun (3.0.1~git20131115.557741b-2) unstable; urgency=low

  * Depend on libglpk-dev.
  * Bump compat version to 9.
  * Replace shogun-dbg with libshogun-dbg (Closes: #729705).
  * Fix minor typo in documentation.

 -- Soeren Sonnenburg <sonne@debian.org>  Fri, 15 Nov 2013 17:32:52 +0100

shogun (3.0.1~git20131115.557741b-1) unstable; urgency=low

  * New upstream version (+additional bugfixes from current git)
  * Rewrite packaging to use debhelper and cmake: Drop all static and modular
  interfaces from this source package and do these later for each individual
  interface with separate source packages to keep shogun in debian.

 -- Soeren Sonnenburg <sonne@debian.org>  Fri, 15 Nov 2013 14:28:11 +0100

shogun (1.1.0-6) unstable; urgency=low

  * Fix error occurring on package upgrades (Closes: #682166)

 -- Soeren Sonnenburg <sonne@debian.org>  Sat, 30 Jun 2012 22:52:04 +0200

shogun (1.1.0-5) unstable; urgency=low

  * Disable 'libatlas-base-dev' build dependency for armhf builds. Thanks
  Hector Oron for the patch. (Closes: #667468)
  * Add temporary workaround for FTBFS with ld --as-needed. Thanks Leo Iannacone
  for the patch. (Closes: #657434)
  * Upload to unstable. (Closes: #669005)

 -- Soeren Sonnenburg <sonne@debian.org>  Tue, 24 Jan 2012 20:19:47 +0100

=== debian/control ===
Source: shogun
Section: science
Priority: optional
Maintainer: Soeren Sonnenburg <sonne@debian.org>
Build-Depends: libatlas-base-dev [!powerpc !alpha !arm !armel !armhf !sh4] | liblapack-dev,
 libeigen3-dev, debhelper (>= 9), libreadline-dev | libreadline5-dev, ghostscript,
 libblas-dev, doxygen-latex, graphviz, libglpk-dev, libnlopt-dev,
 liblzo2-dev, zlib1g-dev, liblzma-dev, libxml2-dev, libjson0-dev, cmake,
 libarpack2-dev, libsnappy-dev, libhdf5-dev (>= 1.8.8~) | libhdf5-serial-dev,
Standards-Version: 3.9.4
Homepage: http://www.shogun-toolbox.org
Vcs-Svn: http://bollin.googlecode.com/svn/shogun/trunk/
Vcs-Browser: http://bollin.googlecode.com/svn/shogun/trunk/

Package: libshogun14
Conflicts: libshogunui6, libshogunui5, libshogunui4, libshogunui3,
 libshogunui2, libshogunui1, libshogunui0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This is the core
 library with the machine learning methods and ui helpers all interfaces are
 based on.

Package: libshogun-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun14 (= ${binary:Version})
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This package
 includes the developer files required to create stand-a-lone executables.

Package: shogun-doc-en
Conflicts: shogun-doc
Replaces: shogun-doc
Section: doc
Architecture: all
Recommends: libshogun-dev
Depends: ${misc:Depends}
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This is the English
 user and developer documentation.

Package: shogun-doc-cn
Section: doc
Architecture: all
Recommends: libshogun-dev
Depends: ${misc:Depends}
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This is the 
 Chinese user and developer documentation.

Package: libshogun-dbg
Breaks: shogun-dbg
Replaces: shogun-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libshogun14 (= ${binary:Version})
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This package
 contains debug symbols for all interfaces.

Package: shogun-cmdline-static
Conflicts: shogun-cmdline
Replaces: shogun-cmdline
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun14 (= ${binary:Version})
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This is the Readline
 package.

## shogun 3.1.1

=== CMakeLists.txt ===
# Instructions:
# $ mkdir build
# $ cd build
# $ cmake ..
# $ make

project(shogun)
cmake_minimum_required(VERSION 2.8.8)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
include(ShogunUtils)

# CCACHE
OPTION(ENABLE_CCACHE "Enable ccache for compilation" ON)
FIND_PACKAGE(CCache)
if(CCACHE_FOUND AND ENABLE_CCACHE)
	SET(CCACHE "ccache" CACHE STRING "ccache")
	SET(CMAKE_C_COMPILER_ARG1 ${CMAKE_C_COMPILER})
	SET(CMAKE_C_COMPILER ${CCACHE})
	SET(CMAKE_CXX_COMPILER_ARG1 ${CMAKE_CXX_COMPILER})
	SET(CMAKE_CXX_COMPILER ${CCACHE})
	SET(CMAKE_C_FLAGS "${CCACHE_FLAGS} ${CMAKE_C_FLAGS}")
	SET(CMAKE_CXX_FLAGS "${CCACHE_FLAGS} ${CMAKE_CXX_FLAGS}")
endif()

SET(CPACK_PACKAGE_CONTACT shogun@shogun-toolbox.org)

################# VARIABLES #####################
SET(DEFINES "SWIG_TYPE_TABLE=shogun;SHOGUN")
SET(INCLUDES "")

SET(EXT_SRC_HEADER "h")
SET(EXT_SRC_C "c")
SET(EXT_SRC_CPP "cpp")
SET(EXT_SRC_SWIG "_wrap.cxx")
SET(EXT_SRC_TEST "_unittest.cc")
SET(EXT_INP_SWIG "i")
SET(EXT_IF_SWIG "py")
SET(EXT_CPP_TMP "${EXT_SRC_CPP}.templ")
SET(EXT_CPP_SH "${EXT_SRC_CPP}.sh")
SET(EXT_CPP_PY "${EXT_SRC_CPP}.py")
SET(EXT_SRC_TEST_TMP "${EXT_SRC_TEST}.jinja2")

SET(THIRD_PARTY_DIR ${CMAKE_SOURCE_DIR}/third_party)
SET(LIBSHOGUN_SRC_DIR ${CMAKE_SOURCE_DIR}/src/shogun)
SET(COMMON_MODULAR_SRC_DIR ${CMAKE_SOURCE_DIR}/src/interfaces/modular/)

# check whether any of the modular interfaces are turned ON
IF (
	PythonModular OR LuaModular OR RModular OR
	OctaveModular OR JavaModular OR PerlModular OR
	RubyModular OR CSharpModular
   )
	FIND_PACKAGE(SWIG 2.0.4 REQUIRED)
	# use our own UseSWIG.cmake in order to be able to enable ccache-swig
	SET(SWIG_USE_FILE ${CMAKE_SOURCE_DIR}/cmake/UseSWIG.cmake)
	IF(ENABLE_CCACHE AND CCACHE_SWIG)
		SET(CCACHE_SWIG_EXECUTABLE ${CCACHE_SWIG})
	ENDIF()
	SET(COMPILE_MODULAR_INTERFACE 1)
ENDIF()

# Detect OS
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	SET(DARWIN 1)
ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	SET(LINUX 1)
ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
	SET(FREEBSD 1)
ENDIF()

# Get processor type, sets MACHINE macro
SET(MACHINE ${CMAKE_SYSTEM_PROCESSOR})

SET(EXT_LIB_SWIG_RUBY_MODULAR ".so")
if(DARWIN)
	SET(EXT_LIB_SWIG_RUBY_MODULAR ".bundle")
ENDIF()

################ COMPILER #######################
# g++ version needs to be => 4.3
IF(CMAKE_COMPILER_IS_GNUCXX)
	# in order to support cmake 2.8.7 and older
	IF(NOT CMAKE_CXX_COMPILER_VERSION)
		include(CheckCompiler)
	ENDIF()
	IF("${CMAKE_CXX_COMPILER_VERSION}" VERSION_LESS "4.3.0")
		MESSAGE(FATAL_ERROR "g++ version is too old")
	ENDIF()
ENDIF()

#Build type
if( NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING
       "Choose the type of build, options are: Debug Release Distribution."
       FORCE )
endif()

# set the flags for the build types
IF(MSVC)
	SET(COMPILER_WARNINGS "/Wall")
ELSE()
	SET(COMPILER_WARNINGS "-Wall -Wno-unused-parameter -Wformat -Wformat-security -Wparentheses -Wshadow -Wno-unknown-pragmas -Wno-deprecated")
ENDIF()

IF(CMAKE_COMPILER_IS_GNUCXX)
	SET(RELEASE_COMPILER_FLAGS "-fexpensive-optimizations -frerun-cse-after-loop -fcse-follow-jumps -finline-functions -fschedule-insns2 -fthread-jumps -fforce-addr -fstrength-reduce -funroll-loops -mfpmath=sse")
ELSEIF("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
	SET(RELEASE_COMPILER_FLAGS "-finline-functions -funroll-loops")
ENDIF()
SET(SWIG_CXX_COMPILER_FLAGS "-O0 -g")
SET(CMAKE_C_FLAGS "${COMPILER_WARNINGS} -g ${CMAKE_C_FLAGS}")
SET(CMAKE_CXX_FLAGS "${COMPILER_WARNINGS} -g ${CMAKE_CXX_FLAGS}")
SET(CMAKE_C_FLAGS_RELEASE "-O3 ${RELEASE_COMPILER_FLAGS}")
SET(CMAKE_CXX_FLAGS_RELEASE "-O3 ${RELEASE_COMPILER_FLAGS}")
SET(CMAKE_C_FLAGS_DISTRIBUTION "-O2")
SET(CMAKE_CXX_FLAGS_DISTRIBUTION "-O2")

OPTION(ENABLE_COVERAGE "Enable code coverage" OFF)
IF(ENABLE_COVERAGE)
	IF(NOT CMAKE_COMPILER_IS_GNUCXX)
		MESSAGE(FATAL_ERROR "Compiler is not GNU gcc! Aborting...")
	ENDIF()
	IF (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
		MESSAGE(WARNING "Code coverage results with an optimised (non-Debug) build may be misleading")
	ENDIF()
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage")
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
	SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
	SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage")
ENDIF()

IF(ENABLE_TSAN)
	IF (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
		MESSAGE(WARNING "Thread-sanitizer results with an optimised (non-Debug) build may be misleading")
	ENDIF()
	SET(SANITIZER_FLAGS "-fsanitize=thread -fPIE")
	SET(SANITIZER_LIBRARY -pie)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		LIST(APPEND SANITIZER_LIBRARY -ltsan)
	ELSEIF("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
		LIST(APPEND SANITIZER_LIBRARY -fsanitize=thread)
	ENDIF()
ENDIF()

IF(ENABLE_ASAN)
	IF (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
		MESSAGE(WARNING "Address-sanitizer results with an optimised (non-Debug) build may be misleading")
	ENDIF()
	SET(SANITIZER_FLAGS "-fsanitize=address -fno-omit-frame-pointer")
	SET(SANITIZER_LIBRARY -fsanitize=address)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		LIST(APPEND SANITIZER_LIBRARY -lasan)
	ENDIF()
ENDIF()

IF(ENABLE_MSAN)
	IF (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
		MESSAGE(WARNING "Memory-sanitizer results with an optimised (non-Debug) build may be misleading")
	ENDIF()
	SET(SANITIZER_FLAGS "-fsanitize=memory -fsanitize-memory-track-origins -fno-omit-frame-pointer")
	SET(SANITIZER_LIBRARY)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		LIST(APPEND SANITIZER_LIBRARY -lmsan)
	ELSEIF("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
		LIST(APPEND SANITIZER_LIBRARY -fsanitize=memory)
	ENDIF()
ENDIF()

IF(ENABLE_UBSAN)
	IF (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
		MESSAGE(WARNING "Memory-sanitizer results with an optimised (non-Debug) build may be misleading")
	ENDIF()
	SET(SANITIZER_FLAGS "-fsanitize=undefined")
	SET(SANITIZER_LIBRARY)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		LIST(APPEND SANITIZER_LIBRARY -lubsan)
	ELSEIF("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
		LIST(APPEND SANITIZER_LIBRARY -fsanitize=undefined)
	ENDIF()
ENDIF()

# check for supported c++11 features
#
# clang with -std=c++11 and -stdlib=libc++ does not work
# well with swig generated cxx hence disable c++11 for this case.

# TODO: until swig 2.0.11 does not support compilation with libc++
# There are PRs against SWIG HEAD to fix this hence it needs to be checked
# which later version can support compilation with libc++
IF (COMPILE_MODULAR_INTERFACE AND ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang") AND NOT SWIG_VERSION VERSION_GREATER "2.0.11")
	SET(CMAKE_CXX_FLAGS "-stdlib=libstdc++ ${CMAKE_CXX_FLAGS}")
	SET(SWIG_CXX_COMPILER_FLAGS "-stdlib=libstdc++ ${SWIG_CXX_COMPILER_FLAGS}")
ENDIF()

IF (NOT ((CYGWIN AND ENABLE_TESTING) OR (DARWIN AND COMPILE_MODULAR_INTERFACE)))
	INCLUDE(CheckCXX11Features)

	IF(_HAS_CXX11_FLAG)
		LIST(APPEND DEFINES HAVE_CXX11)
		SET(HAVE_CXX11 1)
		SET(CMAKE_CXX_FLAGS "${CXX11_COMPILER_FLAGS} ${CMAKE_CXX_FLAGS}")
		SET(SWIG_CXX_COMPILER_FLAGS "${CXX11_COMPILER_FLAGS} ${SWIG_CXX_COMPILER_FLAGS}")
	ENDIF()

	IF(_HAS_CXX0X_FLAG)
		LIST(APPEND DEFINES HAVE_CXX0X)
		SET(HAVE_CXX0X 1)
		SET(CMAKE_CXX_FLAGS "${CXX11_COMPILER_FLAGS} ${CMAKE_CXX_FLAGS}")
		SET(SWIG_CXX_COMPILER_FLAGS "${CXX11_COMPILER_FLAGS} ${SWIG_CXX_COMPILER_FLAGS}")
	ENDIF()

	IF (HAVE_CXX11_ATOMIC)
		LIST(APPEND DEFINES HAVE_CXX11_ATOMIC)
	ENDIF()
ENDIF()

include(CheckIncludeFileCXX)
CHECK_INCLUDE_FILE_CXX("unordered_map" HAVE_STD_UNORDERED_MAP)
IF (HAVE_STD_UNORDERED_MAP)
	LIST(APPEND DEFINES HAVE_STD_UNORDERED_MAP)
ENDIF()

IF(CMAKE_BUILD_TYPE MATCHES "Release")
	# there's a bug on FreeBSD -march=native.
	# for some CPU types it does not detect the right flags
	# see: http://www.freebsd.org/cgi/query-pr.cgi?pr=178792&cat=
	IF (NOT (FREEBSD AND ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")))
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=native")
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
		SET(SWIG_CXX_COMPILER_FLAGS "${SWIG_CXX_COMPILER_FLAGS} -march=native")
	ENDIF()
ENDIF()

###### MALLOC LIBRARY ###########
SET(EXTERNAL_MALLOC_CFLAGS "-fno-builtin-malloc -fno-builtin-calloc -fno-builtin-realloc -fno-builtin-free")
if (MALLOC_REPLACEMENT MATCHES "Jemalloc")
	include(external/Jemalloc)

	SET(USE_JEMALLOC 1)
	LIST(APPEND DEFINES USE_JEMALLOC)
	LIST(INSERT INCLUDES 0 ${Jemalloc_INCLUDE_DIR})
	SET(CMAKE_CXX_FLAGS "${EXTERNAL_MALLOC_CFLAGS} ${CMAKE_CXX_FLAGS}")
	SET(POSTLINKFLAGS ${POSTLINKFLAGS} ${Jemalloc_LIBRARIES})
elseif(MALLOC_REPLACEMENT MATCHES "TCMalloc")
	include(external/TCMalloc)

	SET(USE_TCMALLOC 1)
	LIST(APPEND DEFINES USE_TCMALLOC)
	LIST(INSERT INCLUDES 0 ${TCMalloc_INCLUDE_DIR})
	SET(CMAKE_CXX_FLAGS "${EXTERNAL_MALLOC_CFLAGS} ${CMAKE_CXX_FLAGS}")
	SET(POSTLINKFLAGS ${POSTLINKFLAGS} ${TCMalloc_LIBRARIES})
elseif(MALLOC_REPLACEMENT MATCHES "Hoard")
	find_package(Hoard)
	if (Hoard_FOUND)
		SET(USE_HOARD 1)
		LIST(APPEND DEFINES USE_HOARD)
		SET(POSTLINKFLAGS ${POSTLINKFLAGS} ${Hoard_LIBRARIES})
	else ()
	message(FATAL_ERROR "Unable to use hoard malloc: library not found")
	endif ()
else()
	message(STATUS "Using system's malloc")
endif()

############### VERSION #####################
FILE(STRINGS "@CMAKE_SOURCE_DIR@/NEWS" NEWS LIMIT_COUNT 5)
STRING(REGEX REPLACE ".*SHOGUN Release version ([0-9.]*).*" "\\1" VERSION "${NEWS}")
STRING(REGEX REPLACE ".*SHOGUN Release version.*\\(libshogun ([0-9.]*).*" "\\1" LIBSHOGUNVER "${NEWS}")
STRING(REGEX REPLACE ".*SHOGUN Release version.*\\(libshogun ([0-9]*).*" "\\1" LIBSHOGUNSO "${NEWS}")
STRING(REGEX REPLACE ".*SHOGUN Release version.*data ([0-9.]*).*" "\\1" DATAVER "${NEWS}")
STRING(REGEX REPLACE "([0-9]*).[0-9]*.[0-9]*" "\\1" SHOGUN_VERSION_MAJOR "${VERSION}")
STRING(REGEX REPLACE "[0-9]*.([0-9]*).[0-9]*" "\\1" SHOGUN_VERSION_MINOR "${VERSION}")
STRING(REGEX REPLACE "[0-9]*.[0-9]*.([0-9]*)" "\\1" SHOGUN_VERSION_PATCH "${VERSION}")

SET(BUILD_STATIC "Build a statically linked binary" OFF)
################# EXAMPLES ##################
OPTION(BUILD_EXAMPLES "Build Examples" ON)

################# DATATYPES #################
LIST(APPEND DEFINES USE_CHAR)
LIST(APPEND DEFINES USE_BOOL)
LIST(APPEND DEFINES USE_UINT8)
LIST(APPEND DEFINES USE_UINT16)
#LIST(APPEND DEFINES USE_UINT32)
LIST(APPEND DEFINES USE_UINT64)
#LIST(APPEND DEFINES USE_INT8)
#LIST(APPEND DEFINES USE_INT16)
LIST(APPEND DEFINES USE_INT32)
LIST(APPEND DEFINES USE_INT64)
LIST(APPEND DEFINES USE_FLOAT32)
LIST(APPEND DEFINES USE_FLOAT64)
LIST(APPEND DEFINES USE_COMPLEX128)
#LIST(APPEND DEFINES USE_FLOATMAX)

IF(MSVC)
	include(external/MSIntTypes)
	LIST(APPEND INCLUDES ${THIRD_PARTY_DIR}/MSIntTypes)

	include(external/MSDirent)
	LIST(APPEND INCLUDES ${MSDIRENT_INCLUDE_DIR})
ENDIF()

# detect word size
IF(CMAKE_SIZEOF_VOID_P EQUAL 8 AND NOT DARWIN)
	SET(CMAKE_SWIG_FLAGS -DSWIGWORDSIZE64)
ENDIF()

#interfaces
OPTION(PythonModular "Python Modular" OFF)
OPTION(LuaModular "Lua Modular" OFF)
OPTION(RModular "R Modular" OFF)
OPTION(OctaveModular "Octave Modular" OFF)
OPTION(JavaModular "Java Modular" OFF)
OPTION(PerlModular "Perl Modular" OFF)
OPTION(RubyModular "Ruby Modular" OFF)
OPTION(CSharpModular "CSharp Modular" OFF)

OPTION(PythonStatic "Python Static" OFF)
OPTION(RStatic "R Static" OFF)
OPTION(CmdLineStatic "CmdLine Static" OFF)
OPTION(MatlabStatic "Matlab Static" OFF)
OPTION(OctaveStatic "Octave Static" OFF)

# SVMLight
OPTION(USE_SVMLIGHT "SVMLight" ON)
SET(SVMLightWarning "\n!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!")
SET(SVMLightWarning "${SVMLightWarning}\nWARNING: SHOGUN is built using SVMlight which was written")
SET(SVMLightWarning "${SVMLightWarning}\nby Thorsten Joachims and uses a different non GPL compatible license.")
SET(SVMLightWarning "${SVMLightWarning}\nTo build a fully GPL'd SHOGUN use")
SET(SVMLightWarning "${SVMLightWarning}\nThe SVMlight license can be found in LICENSE.SVMlight.  In case")
SET(SVMLightWarning "${SVMLightWarning}\nyou do not know or cannot agree to the licensing terms expressed in")

=== doc/Makefile ===
.PHONY: doc clean distclean
EXAMPLE_FILES = $(shell find ../examples -name '*.py' -o -name '*.m' -o -name\
				'*.R' -o -name '*.cs' -o -name '*.java' -o -name '*.lua' -o \
				-name '*.rb' -type f)
UNDOCUMENTED_EXAMPLE_DIRS = $(shell find ../examples/undocumented -type d | \
							grep -v svn)
DOCUMENTED_EXAMPLE_DIRS = $(patsubst ../examples/undocumented%,../examples/documented%,\
						  $(UNDOCUMENTED_EXAMPLE_DIRS))
MAINVERSION := $(shell awk '/Release/{print $$5;exit}' ../NEWS)


doc: examples pages/Configure.generated Doxyfile_en Doxyfile_cn
	doxygen Doxyfile_en
	doxygen Doxyfile_cn

Doxyfile_en: Doxyfile_en.in
	sed "s/PROJECT_NUMBER         = .*/PROJECT_NUMBER         = v$(MAINVERSION)/" Doxyfile_en.in >Doxyfile_en

Doxyfile_cn: Doxyfile_cn.in
	sed "s/PROJECT_NUMBER         = .*/PROJECT_NUMBER         = v$(MAINVERSION)/" Doxyfile_cn.in >Doxyfile_cn

pages/Configure.generated:
	cmake --help 2>&1 >$@

doc_cn: examples_cn Doxyfile_cn
	doxygen Doxyfile_cn

examples: $(UNDOCUMENTED_EXAMPLE_DIRS) $(EXAMPLE_FILES)
	$(MAKE) -C ../examples
	echo $(DOCUMENTED_EXAMPLE_DIRS)
	python ./insert_examples.py pages/
	python ./insert_examples_cn.py pages_cn/

distclean: clean

clean:
	rm -rf html html_cn
	rm -f pages/Configure.generated

put-online: doc
	test -n "$(MAINVERSION)"
	ssh km rm -rf "/var/www/shogun-toolbox.org/doc/en/$(MAINVERSION)"
	ssh km mkdir "/var/www/shogun-toolbox.org/doc/en/$(MAINVERSION)"
	cd html && tar --exclude='*.map' --exclude='*.md5' -cjf - . | ssh km tar -C /var/www/shogun-toolbox.org/doc/en/$(MAINVERSION) -xjvf -
	ssh km find /var/www/shogun-toolbox.org/doc/en/$(MAINVERSION) -type f -exec chmod 644 \{\} "\;"
	ssh km find /var/www/shogun-toolbox.org/doc/en/$(MAINVERSION) -type d -exec chmod 755 \{\} "\;"
	#
	ssh km rm -rf "/var/www/shogun-toolbox.org/doc/cn/$(MAINVERSION)"
	ssh km mkdir "/var/www/shogun-toolbox.org/doc/cn/$(MAINVERSION)"
	cd html_cn && tar --exclude='*.map' --exclude='*.md5' -cjf - . | ssh km tar -C /var/www/shogun-toolbox.org/doc/cn/$(MAINVERSION) -xjvf -
	ssh km find /var/www/shogun-toolbox.org/doc/cn/$(MAINVERSION) -type f -exec chmod 644 \{\} "\;"
	ssh km find /var/www/shogun-toolbox.org/doc/cn/$(MAINVERSION) -type d -exec chmod 755 \{\} "\;"

=== examples/CMakeLists.txt ===
IF (NOT TRAVIS_DISABLE_LIBSHOGUN_TESTS)
	add_subdirectory(undocumented/libshogun)
ENDIF()

IF (PythonModular)
	add_subdirectory(undocumented/python_modular)
ENDIF()

# lua modular
IF (LuaModular)
	add_subdirectory(undocumented/lua_modular)
ENDIF()

# java modular
IF (JavaModular)
	add_subdirectory(undocumented/java_modular)
ENDIF()

# ruby modular
IF (RubyModular)
	add_subdirectory(undocumented/ruby_modular)
ENDIF()

# octave modular
IF (OctaveModular)
	add_subdirectory(undocumented/octave_modular)
ENDIF()

# csharp modular
IF (CSharpModular)
	add_subdirectory(undocumented/csharp_modular)
ENDIF()

# r modular
IF (RModular)
	add_subdirectory(undocumented/r_modular)
ENDIF()

# perl modular
IF (PerlModular)
	#add_subdirectory(undocumented/perl_modular)
ENDIF()

IF (MatlabStatic)
	#add_subdirectory(undocumented/matlab_static)
ENDIF()

IF (CmdLineStatic)
	add_subdirectory(undocumented/cmdline_static)
ENDIF()

=== applications/msplicer/Makefile ===
release-dir := msplicer-0.3

release:
	( cd .. ; mkdir -p $(release-dir)/data ; \
	cp python/msplicer python/LICENSE python/README python/NEWS python/*.py $(release-dir) ; \
	tar cjvf $(release-dir).tar.bz2 $(release-dir) )
clean:
	rm -f *.pyc

=== applications/vw/Makefile ===
CXXFLAGS=-O9 -g $(INCLUDES)
LINKFLAGS=-lshogun
TARGETS=vw
COMP=g++

all: $(TARGETS)

clean:
	rm -f $(TARGETS)

$(TARGETS): $(foreach t, $(TARGET), $t.cpp)

%: %.cpp
	$(COMP) $(CXXFLAGS) $< $(LINKFLAGS) -o $@

=== doc/tutorial/Makefile ===
all:
	pdflatex shogun_tutorial.tex
	bibtex shogun_tutorial
	pdflatex shogun_tutorial.tex
	pdflatex shogun_tutorial.tex
	pdflatex shogun_tutorial.tex

=== src/shogun/CMakeLists.txt ===
if(SYSTEM_INCLUDES)
  INCLUDE_DIRECTORIES(SYSTEM ${SYSTEM_INCLUDES})
endif()
include_directories(${INCLUDES} . ..)

FILE(GLOB_RECURSE LIBSHOGUN_SRC *.${EXT_SRC_CPP} *.${EXT_SRC_C})
FILE(GLOB_RECURSE LIBSHOGUN_HEADERS *.${EXT_SRC_HEADER})
FILE(GLOB_RECURSE LIBSHOGUN_SRC_TMP *.${EXT_CPP_TMP})

IF (PROTOBUF_FOUND)
	FILE(GLOB protobuf_src ${CMAKE_CURRENT_SOURCE_DIR}/io/protobuf/*.proto)

	FOREACH(FIL ${protobuf_src})
		get_filename_component(FIL_WE ${FIL} NAME_WE)
		SET(name "${CMAKE_CURRENT_SOURCE_DIR}/io/protobuf/${FIL_WE}")
		list(APPEND LIBSHOGUN_SRC "${name}.pb.cc")
		list(APPEND LIBSHOGUN_HEADERS "${name}.pb.h")
	ENDFOREACH()
ENDIF()

# add target to compile the libshogun sources
add_library(libshogun OBJECT ${LIBSHOGUN_SRC} base/class_list.cpp)
set_target_properties(libshogun PROPERTIES
    COMPILE_DEFINITIONS "${DEFINES}"
    POSITION_INDEPENDENT_CODE TRUE)
IF (SANITIZER_FLAGS)
  set_target_properties(libshogun PROPERTIES COMPILE_FLAGS ${SANITIZER_FLAGS})
ENDIF()

IF (PROTOBUF_FOUND)
	FOREACH(FIL ${protobuf_src})
		get_filename_component(FIL_WE ${FIL} NAME_WE)

		SET(name "${CMAKE_CURRENT_SOURCE_DIR}/io/protobuf/${FIL_WE}")

		ADD_CUSTOM_COMMAND(
			 OUTPUT "${name}.pb.cc" "${name}.pb.h"
			 COMMAND ${PROTOBUF_PROTOC_EXECUTABLE} ${FIL}
				 --cpp_out ${CMAKE_CURRENT_SOURCE_DIR}/io/protobuf
				 --proto_path ${CMAKE_CURRENT_SOURCE_DIR}/io/protobuf
			 COMMENT "Running C++ protocol buffer compiler on ${FIL_WE}.proto"
			)
		ADD_CUSTOM_TARGET("${FIL_WE}Protobuf" DEPENDS "${name}.pb.cc")
		add_dependencies(libshogun "${FIL_WE}Protobuf")
	ENDFOREACH()
ENDIF()

# Generate versionstring.h
ADD_CUSTOM_TARGET(
    version
    ${CMAKE_COMMAND} -D SRC=${CMAKE_CURRENT_SOURCE_DIR}/lib/versionstring.h.in
                     -D DST=${CMAKE_CURRENT_SOURCE_DIR}/lib/versionstring.h
                     -D ROOT_DIR=${CMAKE_SOURCE_DIR}
                     -D PYTHON_EXECUTABLE=${PYTHON_EXECUTABLE}
                     -P ${CMAKE_MODULE_PATH}/version.cmake
    COMMENT "Generating version header"
)
add_dependencies(libshogun version)

# generate source files from templates
FOREACH(template ${LIBSHOGUN_SRC_TMP})
  STRING(REGEX REPLACE ${EXT_CPP_TMP} ${EXT_SRC_CPP} generated_cpp "${template}")
  STRING(REGEX REPLACE ${EXT_CPP_TMP} ${EXT_CPP_PY} generator_script "${template}")
  STRING(REGEX REPLACE ".*/(.*).${EXT_CPP_TMP}" "\\1" generated_target "${template}")

  IF(MSVC)
    FOREACH(h ${LIBSHOGUN_HEADERS})
      FILE(APPEND ${CMAKE_CURRENT_BINARY_DIR}/headers_list.txt "${h}\n")
    ENDFOREACH()

    ADD_CUSTOM_COMMAND(OUTPUT ${generated_cpp}
        COMMAND ${CMAKE_COMMAND} -E copy ${template} ${generated_cpp}
        COMMAND ${PYTHON_EXECUTABLE} ${generator_script} ${generated_cpp} -in ${CMAKE_CURRENT_BINARY_DIR}/headers_list.txt
        DEPENDS ${template} ${generator_script} ${LIBSHOGUN_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/headers_list.txt
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        COMMENT "Generating ${generated_cpp}"
    )
  ELSE()
    ADD_CUSTOM_COMMAND(OUTPUT ${generated_cpp}
        COMMAND ${CMAKE_COMMAND} -E copy ${template} ${generated_cpp}
        COMMAND ${PYTHON_EXECUTABLE} ${generator_script} ${generated_cpp} ${LIBSHOGUN_HEADERS}
        DEPENDS ${template} ${generator_script} ${LIBSHOGUN_HEADERS}
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        COMMENT "Generating ${generated_cpp}"
    )
  ENDIF()

  ADD_CUSTOM_TARGET(${generated_target} DEPENDS ${generated_cpp})
  add_dependencies(libshogun ${generated_target})
ENDFOREACH()

# add target for dynamic
add_library(shogun SHARED $<TARGET_OBJECTS:libshogun> lib/config.h)
set_target_properties(shogun PROPERTIES
                      VERSION ${LIBSHOGUNVER}
                      SOVERSION ${LIBSHOGUNSO})

target_link_libraries(shogun ${POSTLINKFLAGS})

# add bundled libraries to dependency
if(SHOGUN_DEPENDS)
  add_dependencies(libshogun ${SHOGUN_DEPENDS})
endif()

# add target for static library if enabled
if (BUILD_STATIC)
  add_library(shogun-static STATIC $<TARGET_OBJECTS:libshogun> lib/config.h)
  set_target_properties(shogun-static PROPERTIES OUTPUT_NAME shogun)
ENDIF()

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/lib/config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/lib/config.h)

INSTALL(DIRECTORY ./
        DESTINATION include/shogun
        COMPONENT headers
        FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp"
        PATTERN ".settings" EXCLUDE)
SET(CPACK_COMPONENTS_ALL ${CPACK_COMPONENTS_ALL} headers)

IF (LIB_INSTALL_DIR)
  SET(SHOGUN_LIB_INSTALL ${LIB_INSTALL_DIR})
ELSE()
  SET(SHOGUN_LIB_INSTALL lib)
ENDIF()

INSTALL(TARGETS shogun
  ARCHIVE DESTINATION ${SHOGUN_LIB_INSTALL}
  LIBRARY DESTINATION ${SHOGUN_LIB_INSTALL}
  COMPONENT libraries)

SET(CPACK_COMPONENTS_ALL ${CPACK_COMPONENTS_ALL} libraries PARENT_SCOPE)

# cpack
set(CPACK_COMPONENT_LIBRARIES_DISPLAY_NAME "Libraries" PARENT_SCOPE)
set(CPACK_COMPONENT_LIBRARIES_DESCRIPTION "Shogun libraries" PARENT_SCOPE)
set(CPACK_COMPONENT_LIBRARIES_GROUP "Runtime" PARENT_SCOPE)

set(CPACK_COMPONENT_HEADERS_DISPLAY_NAME "C++ Headers" PARENT_SCOPE)
set(CPACK_COMPONENT_HEADERS_DESCRIPTION "C/C++ header files for Shogun" PARENT_SCOPE)
set(CPACK_COMPONENT_HEADERS_GROUP "Development" PARENT_SCOPE)

set(CPACK_COMPONENT_GROUP_DEVELOPMENT_EXPANDED ON PARENT_SCOPE)
set(CPACK_COMPONENT_GROUP_DEVELOPMENT_DESCRIPTION
   "All of the packages that's required for developing with Shogun" PARENT_SCOPE)

set(CPACK_COMPONENT_HEADERS_DEPENDS libraries PARENT_SCOPE)

=== tests/integration/CMakeLists.txt ===
# Generate the list of integration tests
FILE(GLOB_RECURSE INTEGRATION_TESTS data/*.m)
FILE(READ blacklist INTEGRATION_BLACKLIST)
STRING(REGEX REPLACE ";" "\\\\;" INTEGRATION_BLACKLIST "${INTEGRATION_BLACKLIST}")
STRING(REGEX REPLACE "\n" ";" INTEGRATION_BLACKLIST "${INTEGRATION_BLACKLIST}")

unset(_tmp)
FOREACH(IB ${INTEGRATION_BLACKLIST})
	list(APPEND _tmp ${CMAKE_CURRENT_SOURCE_DIR}/data/${IB})
ENDFOREACH()
set(INTEGRATION_BLACKLIST ${_tmp})

LIST(REMOVE_ITEM INTEGRATION_TESTS ${INTEGRATION_BLACKLIST})
unset(INTEGRATION_BLACKLIST)

IF (PythonModular)
	add_subdirectory(python_modular)
ENDIF()



unset(INTEGRATION_TESTS)

=== tests/unit/CMakeLists.txt ===
# transform defines to -D<definition> string
foreach(D IN LISTS DEFINES)
	SET(CMAKE_DEFINITIONS "${CMAKE_DEFINITIONS} -D${D}")
endforeach()

# Find GTEST and GMOCK frameworks
include(external/GoogleTestNMock)
ExternalProject_Get_Property(GoogleMock source_dir)
if(SYSTEM_INCLUDES)
	INCLUDE_DIRECTORIES(SYSTEM ${SYSTEM_INCLUDES})
endif()
include_directories(${source_dir}/include ${INCLUDES} ${source_dir}/gtest/include ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src)
LINK_DIRECTORIES(${THIRD_PARTY_DIR}/libs/gmock)

# Generate automatic unittest from jinja2 templates
ADD_CUSTOM_COMMAND(OUTPUT clone_unittest.cc
	COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.py
	${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.jinja2
	clone_unittest.cc
	${LIBSHOGUN_SRC_DIR}/base/class_list.cpp
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.py
	${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.jinja2
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating clone_unittest.cc")
LIST(APPEND TEMPLATE_GENERATED_UNITTEST clone_unittest.cc)

ADD_CUSTOM_COMMAND(OUTPUT SerializationAscii_unittest.cc
	COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.py
	${CMAKE_CURRENT_SOURCE_DIR}/io/SerializationAscii_unittest.cc.jinja2
	SerializationAscii_unittest.cc
	${LIBSHOGUN_SRC_DIR}/base/class_list.cpp
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.py
	${CMAKE_CURRENT_SOURCE_DIR}/io/SerializationAscii_unittest.cc.jinja2
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating SerializationAscii_unittest.cc")
LIST(APPEND TEMPLATE_GENERATED_UNITTEST SerializationAscii_unittest.cc)

ADD_CUSTOM_COMMAND(OUTPUT SerializationHDF5_unittest.cc
	COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.py
	${CMAKE_CURRENT_SOURCE_DIR}/io/SerializationHDF5_unittest.cc.jinja2
	SerializationHDF5_unittest.cc
	${LIBSHOGUN_SRC_DIR}/base/class_list.cpp
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.py
	${CMAKE_CURRENT_SOURCE_DIR}/io/SerializationHDF5_unittest.cc.jinja2
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating SerializationHDF5_unittest.cc")
LIST(APPEND TEMPLATE_GENERATED_UNITTEST SerializationHDF5_unittest.cc)

ADD_CUSTOM_COMMAND(OUTPUT SerializationJSON_unittest.cc
	COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.py
	${CMAKE_CURRENT_SOURCE_DIR}/io/SerializationJSON_unittest.cc.jinja2
	SerializationJSON_unittest.cc
	${LIBSHOGUN_SRC_DIR}/base/class_list.cpp
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.py
	${CMAKE_CURRENT_SOURCE_DIR}/io/SerializationJSON_unittest.cc.jinja2
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating SerializationJSON_unittest.cc")
LIST(APPEND TEMPLATE_GENERATED_UNITTEST SerializationJSON_unittest.cc)

ADD_CUSTOM_COMMAND(OUTPUT SerializationXML_unittest.cc
	COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.py
	${CMAKE_CURRENT_SOURCE_DIR}/io/SerializationXML_unittest.cc.jinja2
	SerializationXML_unittest.cc
	${LIBSHOGUN_SRC_DIR}/base/class_list.cpp
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/base/clone_unittest.cc.py
	${CMAKE_CURRENT_SOURCE_DIR}/io/SerializationXML_unittest.cc.jinja2
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating SerializationXML_unittest.cc")
LIST(APPEND TEMPLATE_GENERATED_UNITTEST SerializationXML_unittest.cc)

add_executable (discover_gtest_tests
       ${CMAKE_CURRENT_SOURCE_DIR}/discover_gtest_tests.cpp)

# collect the unittests
FILE(GLOB_RECURSE UNITTEST_SRC *_unittest.cc)

ADD_EXECUTABLE(shogun-unit-test ${UNITTEST_SRC} ${TEMPLATE_GENERATED_UNITTEST})
target_link_libraries(shogun-unit-test shogun gmock gtest ${SANITIZER_LIBRARY})
set_target_properties(shogun-unit-test PROPERTIES COMPILE_DEFINITIONS "${DEFINES}")
IF (SANITIZER_FLAGS)
	set_target_properties(shogun-unit-test PROPERTIES COMPILE_FLAGS ${SANITIZER_FLAGS})
ENDIF()

ADD_CUSTOM_TARGET(unit-tests
	COMMAND ${CMAKE_CURRENT_BINARY_DIR}/shogun-unit-test
	DEPENDS shogun-unit-test)

shogun_discover_tests(shogun-unit-test)

unset(CMAKE_DEFINITIONS)

=== tests/unit/Makefile ===
SHOGUNSRCTOP=../../src
#VALGRINDOPTS=
VALGRINDOPTS=--leak-check=full

ifeq ($(SHOGUNSRCTOP)/.config,$(wildcard $(SHOGUNSRCTOP)/.config))
CONFIGPATH = $(SHOGUNSRCTOP)
all: build
include $(SHOGUNSRCTOP)/.config
else
all:
	@echo !!! Please run ./configure in $(SHOGUNSRCTOP) directory with the appropriate options first !!!
endif

TESTSRCFILES = $(shell find $(SRCDIR) -name "*$(EXT_SRC_TEST)")
TMPFILES	 = $(shell find $(SRCDIR) -name "*.cc.jinja2")
SRCTMPFILES  = $(TMPFILES:.cc.jinja2=.cc)
TESTSRCFILES += $(SRCTMPFILES)
TESTOBJFILES = $(patsubst %$(EXT_SRC_TEST),%$(EXT_OBJ_TEST), $(TESTSRCFILES))

gtest-all.o: $(GTEST_DIR)/src/gtest-all.cc
	@$(COMP_CPP) $(COMPFLAGS_CPP) $(INCLUDES) $(DEFINES) -I$(SHOGUNSRCTOP) $(COMPFLAGS_GTEST_CPP) $(COMPFLAGS_GMOCK_CPP) -I$(GTEST_DIR) -I$(GMOCK_DIR) -c $<
	@echo 'Compiling gtest'

gmock-all.o: $(GMOCK_DIR)/src/gmock-all.cc
	@$(COMP_CPP) $(COMPFLAGS_CPP) $(INCLUDES) $(DEFINES) -I$(SHOGUNSRCTOP) $(COMPFLAGS_GTEST_CPP) $(COMPFLAGS_GMOCK_CPP) -I$(GTEST_DIR) -I$(GMOCK_DIR) -c $<
	@echo 'Compiling gmock'

libgmock.a: gtest-all.o gmock-all.o
	@ar -crv libgmock.a gtest-all.o gmock-all.o
	@echo 'Creating gmock library'

shogun-lib:
	@$(MAKE) -C $(SHOGUNSRCTOP)/shogun

shogun-unit-test: libgmock.a shogun-lib $(TESTOBJFILES)
	@$(LINK) -o shogun-unit-test $(TESTOBJFILES) $(LINKFLAGS) -L$(SHOGUNSRCTOP)/shogun -lshogun libgmock.a $(LINKFLAGS_GMOCK) $(POSTLINKFLAGS)

build: shogun-unit-test
	@$(LIBRARY_PATH)=$(SHOGUNSRCTOP)/shogun:$$$(LIBRARY_PATH) ./shogun-unit-test

valgrind: shogun-unit-test
	@$(LIBRARY_PATH)=$(SHOGUNSRCTOP)/shogun:$$$(LIBRARY_PATH) valgrind $(VALGRINDOPTS) ./shogun-unit-test

valgrind-per-module: shogun-unit-test
	@$(LIBRARY_PATH)=$(SHOGUNSRCTOP)/shogun:$$$(LIBRARY_PATH) ./shogun-unit-test --gtest_list_tests \
	 | grep -E '^[a-zA-Z0-9]*\.' \
	 | $(LIBRARY_PATH)=$(SHOGUNSRCTOP)/shogun:$$$(LIBRARY_PATH) \
	 xargs -I{} valgrind $(VALGRINDOPTS) ./shogun-unit-test --gtest_filter={}\*

%$(EXT_OBJ_TEST): %$(EXT_SRC_TEST)
	@$(COMP_CPP) -I$(SHOGUNSRCTOP) $(COMPFLAGS_CPP) $(COMPFLAGS_GTEST_CPP) $(COMPFLAGS_GMOCK_CPP) $(DEFINES) -c $(INCLUDES) -o $@ $<
	@echo 'Compiling $@'
	@test -f $<.jinja2 && rm -f $< || true

%$(EXT_SRC_TEST):
	@echo Generating $@
	@$(PYTHON) $@.py $@.jinja2

clean:
	@rm -f ./shogun-unit-test libgmock.a gmock-all.o gtest-all.o $(TESTOBJFILES) $(SRCTMPFILES)
	@echo 'Removing compiled binaries'

=== examples/undocumented/csharp_modular/CMakeLists.txt ===
FILE(GLOB TARGETS_SRC RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*.cs)
LIST(REMOVE_ITEM TARGETS_SRC Load.cs)
IF (NOT USE_SVMLIGHT)

ENDIF()

SET(CSHARP_FLAGS "${CMAKE_CURRENT_SOURCE_DIR}/Load.cs;/lib:${CSHARP_MODULAR_BUILD_DIR};/r:modshogun")

FOREACH(EXAMPLE_SRC ${TARGETS_SRC})
	STRING(REGEX REPLACE "(.*).cs" "csharp-\\1" EXAMPLE_NAME ${EXAMPLE_SRC})
	STRING(REGEX REPLACE "(.*).cs" "\\1.exe" EXAMPLE_BINARY ${EXAMPLE_SRC})

	ADD_CUSTOM_COMMAND(OUTPUT ${EXAMPLE_NAME}
		COMMAND	${CSHARP_COMPILER} ${CMAKE_CURRENT_SOURCE_DIR}/${EXAMPLE_SRC} ${CSHARP_FLAGS} -out:${EXAMPLE_BINARY}
		DEPENDS csharp_modular
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
	LIST(APPEND CSHARP_EXAMPLES ${EXAMPLE_NAME})

	add_test(NAME ${EXAMPLE_NAME}
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		COMMAND ${CSHARP_INTERPRETER} ${CMAKE_CURRENT_BINARY_DIR}/${EXAMPLE_BINARY})
	set_property(TEST ${EXAMPLE_NAME} PROPERTY
		ENVIRONMENT "MONO_PATH=${CSHARP_MODULAR_BUILD_DIR}")
ENDFOREACH()

add_custom_target(build_csharp_examples ALL
				 DEPENDS ${CSHARP_EXAMPLES}
				 COMMENT "C# examples")

=== examples/undocumented/java_modular/CMakeLists.txt ===
FILE(GLOB EXAMPLES_SRC RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*.java)
LIST(REMOVE_ITEM EXAMPLES_SRC Load.java)

SET(CLASSPATH "${JBLAS}:${SHOGUN_JAR}:${CMAKE_CURRENT_BINARY_DIR}")
SET(JAVAOPTS "-Xmx1024m")
SET(JAVA_LIB_PATH "${JAVA_MODULAR_BUILD_DIR}")

ADD_CUSTOM_COMMAND(OUTPUT Load.class
				  COMMAND ${Java_JAVAC_EXECUTABLE} -cp ${CLASSPATH}
					-d ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/Load.java
				  DEPENDS shogun_jar)

FOREACH(EXAMPLE_SRC ${EXAMPLES_SRC})
	get_filename_component(EXAMPLE_NAME ${EXAMPLE_SRC} NAME_WE)

	ADD_CUSTOM_COMMAND(OUTPUT ${EXAMPLE_NAME}.class
				  COMMAND ${Java_JAVAC_EXECUTABLE} -cp ${CLASSPATH}
					-d ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/${EXAMPLE_SRC}
				  DEPENDS shogun_jar Load.class)
	LIST(APPEND JAVA_EXAMPLES ${EXAMPLE_NAME}.class)

	add_test(NAME java_modular-${EXAMPLE_NAME}
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			COMMAND ${Java_JAVA_EXECUTABLE} ${JAVAOPTS}
				-cp ${CLASSPATH}
				-Djava.library.path=${JAVA_LIB_PATH} ${EXAMPLE_NAME})
ENDFOREACH()

add_custom_target(build_java_examples ALL
				 DEPENDS Load.class ${JAVA_EXAMPLES}
				 COMMENT "Java examples")

=== debian/changelog ===
shogun (3.1.1-1) unstable; urgency=low

  * New upstream version

 -- Soeren Sonnenburg <sonne@debian.org>  Sun, 05 Jan 2014 09:35:46 +0100

shogun (3.1.0-1) unstable; urgency=low

  * New upstream version
  * Bump standards version to 3.9.5 (no changes required).

 -- Soeren Sonnenburg <sonne@debian.org>  Sun, 05 Jan 2014 08:34:52 +0100

=== debian/control ===
--- 
+++ 
@@ -7,12 +7,12 @@
  libblas-dev, doxygen-latex, graphviz, libglpk-dev, libnlopt-dev,
  liblzo2-dev, zlib1g-dev, liblzma-dev, libxml2-dev, libjson0-dev, cmake,
  libarpack2-dev, libsnappy-dev, libhdf5-dev (>= 1.8.8~) | libhdf5-serial-dev,
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://www.shogun-toolbox.org
 Vcs-Svn: http://bollin.googlecode.com/svn/shogun/trunk/
 Vcs-Browser: http://bollin.googlecode.com/svn/shogun/trunk/
 
-Package: libshogun14
+Package: libshogun15
 Conflicts: libshogunui6, libshogunui5, libshogunui4, libshogunui3,
  libshogunui2, libshogunui1, libshogunui0
 Architecture: any
@@ -43,7 +43,7 @@
 Package: libshogun-dev
 Section: libdevel
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun14 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun15 (= ${binary:Version})
 Description: Large Scale Machine Learning Toolbox
  SHOGUN - is a new machine learning toolbox with focus on large scale kernel
  methods and especially on Support Vector Machines (SVM) with focus to
@@ -125,7 +125,7 @@
 Section: debug
 Priority: extra
 Architecture: any
-Depends: ${misc:Depends}, libshogun14 (= ${binary:Version})
+Depends: ${misc:Depends}, libshogun15 (= ${binary:Version})
 Description: Large Scale Machine Learning Toolbox
  SHOGUN - is a new machine learning toolbox with focus on large scale kernel
  methods and especially on Support Vector Machines (SVM) with focus to
@@ -151,7 +151,7 @@
 Conflicts: shogun-cmdline
 Replaces: shogun-cmdline
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun14 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun15 (= ${binary:Version})
 Description: Large Scale Machine Learning Toolbox
  SHOGUN - is a new machine learning toolbox with focus on large scale kernel
  methods and especially on Support Vector Machines (SVM) with focus to

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR = $(CURDIR)/debian/build

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=TRUE -DBUILD_EXAMPLES=OFF -DUSE_SVMLIGHT=OFF -DCmdLineStatic=ON

override_dh_install:
	$(MAKE) -C doc doc
	$(RM) doc/html*/*.map
	$(RM) doc/html*/*.md5
	$(RM) doc/html*/installdox
	$(RM) doc/html*/formula.repository
	mkdir -p $(CURDIR)/debian/shogun-doc-en/usr/share/doc/shogun-doc-en
	mkdir -p $(CURDIR)/debian/shogun-doc-cn/usr/share/doc/shogun-doc-cn
	cp -r doc/html $(CURDIR)/debian/shogun-doc-en/usr/share/doc/shogun-doc-en
	cp -r doc/html_cn $(CURDIR)/debian/shogun-doc-cn/usr/share/doc/shogun-doc-cn
	dh_install

override_dh_strip:
	dh_strip --dbg-package=libshogun-dbg

=== debian/watch ===
version=3
http://www.shogun-toolbox.org .*/shogun-([\d\.]+).tar.bz2 \
 debian debian/orig-tar.sh
